import { TransactionStatus } from "fireblocks-sdk";
import { BridgeParams } from "../interfaces/bridge-params";
export declare const CHAIN_TO_ASSET_ID: {
    [key: string]: string;
};
export declare const CHAIN_IDS: {
    mainnet: number;
    ropsten: number;
    rinkeby: number;
    goerli: number;
    kovan: number;
    bsc: number;
    bsc_test: number;
    matic: number;
    arbitrum: number;
    maticmum: number;
    fantom: number;
    avalanche: number;
};
export declare abstract class BaseBridge {
    readonly params: BridgeParams;
    readonly assetId: string;
    static readonly finalTransactionStates: TransactionStatus[];
    constructor(params: BridgeParams);
    getDepositAddress(): Promise<string>;
    getChainId(): number;
    waitForTxHash(txId: string, timeoutMs?: number): Promise<string>;
}
