"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EthersBridge = void 0;
const fireblocks_sdk_1 = require("fireblocks-sdk");
const base_bridge_1 = require("./base-bridge");
const utils_1 = require("ethers/lib/utils");
class EthersBridge extends base_bridge_1.BaseBridge {
    sendTransaction(transaction, txNote) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const txArguments = {
                operation: fireblocks_sdk_1.TransactionOperation.CONTRACT_CALL,
                assetId: this.assetId,
                source: {
                    type: fireblocks_sdk_1.PeerType.VAULT_ACCOUNT,
                    id: this.params.vaultAccountId
                },
                gasPrice: transaction.gasPrice != undefined ? (0, utils_1.formatUnits)(transaction.gasPrice.toString(), "gwei") : undefined,
                gasLimit: (_a = transaction.gasLimit) === null || _a === void 0 ? void 0 : _a.toString(),
                destination: {
                    type: this.params.externalWalletId ? fireblocks_sdk_1.PeerType.EXTERNAL_WALLET : fireblocks_sdk_1.PeerType.ONE_TIME_ADDRESS,
                    id: this.params.externalWalletId,
                },
                note: txNote || '',
                amount: (0, utils_1.formatEther)(((_b = transaction.value) === null || _b === void 0 ? void 0 : _b.toString()) || "0"),
                extraParameters: {
                    contractCallData: transaction.data
                }
            };
            if (transaction.to) {
                txArguments.destination.oneTimeAddress = {
                    address: transaction.to
                };
            }
            return this.params.fireblocksApiClient.createTransaction(txArguments);
        });
    }
}
exports.EthersBridge = EthersBridge;
//# sourceMappingURL=ethers-bridge.js.map