"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomToken = void 0;
const base_token_1 = require("./base-token");
class CustomToken extends base_token_1.BaseToken {
    constructor(bridgeParams, contractABI) {
        super(bridgeParams, contractABI);
    }
    /**
     * Will activate a read function from the provided Contract ABI
     * @param abiFunctionName
     * @param args - arguments for contract call (addresses should be wrapped with Web3.toChecksumAddress(address)
     */
    callReadFunction(abiFunctionName, ...args) {
        return this.callView(abiFunctionName, ...args);
    }
    /**
     * Will activate a write function from the provided Contract ABI using Fireblocks secure infrastructure
     * @param abiFunctionName
     * @param notes
     * @param args - arguments for contract call (addresses should be wrapped with Web3.toChecksumAddress(address)
     */
    callWriteFunction(abiFunctionName, notes, ...args) {
        return __awaiter(this, void 0, void 0, function* () {
            const transactionData = yield this.buildTransaction(abiFunctionName, ...args);
            return this.submitTransaction(transactionData, notes);
        });
    }
}
exports.CustomToken = CustomToken;
//# sourceMappingURL=custom-token.js.map