"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Utils = void 0;
const node_fetch_1 = __importDefault(require("node-fetch"));
class Utils {
    static fetchABI(contractAddress) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const res = yield (0, node_fetch_1.default)(`https://api.etherscan.io/api?module=contract&action=getabi&address=${contractAddress}`);
                if (res.status !== 200) {
                    throw new Error();
                }
                const contentBlob = yield res.blob();
                const abiString = JSON.parse(yield contentBlob.text());
                return JSON.parse(abiString.result);
            }
            catch (e) {
                throw new Error('Cant fetch or decode ABI');
            }
        });
    }
}
exports.Utils = Utils;
//# sourceMappingURL=utils.js.map